/*
 * crypted.c - part of procsms application
 *
 * Copyright (C) 2003 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "crypted.h"
#include "procsms.h"

#ifdef CONFIG_CRYPTED

/* *INDENT-OFF* */

lc_char PROGMEM lc_Version[]={
        LC_EN("Version")
        LC_CZ("Verze")
        LC_END
};

lc_char PROGMEM lc_Lang[]={
        LC_EN("Language")
        LC_NO("Sprak")
        LC_DE("Sprache")
        LC_CZ("Jazyk")
	LC_FR("Langue")
	LC_DK("Sprog")
        LC_END
};

lc_char PROGMEM lc_Crypted[]={
        LC_EN("Secure SMS")
        LC_CZ("Sifrovane SMS")
	LC_FR("SMS crypt\5")
	LC_DE("Verschl. SMS")
	LC_DK("Krypteret SMS")
        LC_END
};

static lc_char PROGMEM lc_Send_crypted[]={
        LC_EN("Send Secure")
        LC_CZ("Poslat sifr.")
	LC_FR("Envoi crypt\5")
	LC_DE("Verschl. senden")
//	LC_DE("Verschl\176sselt senden")
	LC_DK("Send Krypteret")
        LC_END
};

static lc_char PROGMEM lc_Unlock[]={
        LC_EN("Unlock")
        LC_CZ("Odemknout")
	LC_FR("D\5bloquer")
	LC_DE("Entschl\176sseln")
	LC_DK("L\17s op")
        LC_END
};

static lc_char PROGMEM lc_Setup[]={
        LC_EN("Setup")
        LC_CZ("Nastaveni")
	LC_FR("Configuration")
	LC_DE("Einstellungen")
	LC_DK("Ops\35tning")
        LC_END
};

static lc_char PROGMEM lc_Stealth[]={
        LC_EN("Hide")
        LC_CZ("Skryt")
	LC_FR("Cacher")
	LC_DE("Verstecken")
	LC_DK("Skjul")
        LC_END
};


static lc_char PROGMEM lc_Label[]={
        LC_EN("Secure Label")
        LC_CZ("Oznaceni sifr.")
	LC_FR("Etiquette crypt\5e")
	LC_DE("Markieren")
	LC_DK("Krypteret Tekst")
        LC_END
};

static lc_char PROGMEM lc_Label_Help[]={
        LC_EN("Label for secure SMS, useful for masking that secure messages are used. Does not have to work on every phone.")
        LC_CZ("Oznaceni sifrovane zpravy oznacuje text, ktery telefon zobrazi pri prijeti sifrovane zpravy. Nastavenim vhodneho textu lze maskovat pouziti sifrovanych zprav. Nemusi fungovat na kazdem telefonu.")
	LC_FR("Etiquette pour SMS crypt\5s, utile pour cacher le fait que des messages crypt\5s sont utilis\5s.")
	LC_DE("Die Markierung der versch\176sselten Nachricht bezeichnet den Text der Empfangenen verschl\176sselten SMS. Durch den passenden Text ist die verschl\176sselte Nachricht getarnt. Muss nicht bei jedem Handz funktionieren")
	LC_DK("Krypteret Tekst, bruges til at skjule at krypteret beskeder benyttes. Virker ikke p\17 alle telefoner.")
        LC_END
};

static lc_char PROGMEM lc_Insert[]={
        LC_EN("Create")
        LC_CZ("Vytvorit")
	LC_FR("Creer")
	LC_DE("Entwerfen")
	LC_DK("Opret")
        LC_END
};

lc_char PROGMEM lc_RESET_SMS[]={
        LC_EN("Killing SMS")
        LC_CZ("Blokovaci SMS")
	LC_FR("Tuer SMS")
	LC_DE("Blockade-SMS")
	LC_DK("Dr\35ber SMS")
        LC_END
};

static lc_char PROGMEM lc_Send_RESET_SMS[]={
        LC_EN("Send")
        LC_CZ("Poslat")
	LC_FR("Envoyer")
	LC_DE("Senden")
	LC_DK("Send")
        LC_END
};

static lc_char PROGMEM lc_RESET_SMS_Help[]={
        LC_EN("Killing SMS blocks or resets the mobile phone, useful if phone is lost or stolen.")
        LC_CZ("Blokovaci SMS slouzi k \"zatuhnuti\" ci resetu telefonu, vhodne pri ztrate ci kradezi telefonu.")
	 LC_FR("Tuer SMS bloque ou initialise le GSM, utile si le GSM est perdu ou vol\5.")
	LC_DE("Blokade SMS dient zur Lahmlegung oder Reset vom Handy, hilfreich bei Verlust oder Diebstahl")
	LC_DK("Dr\35ber SMS blokere eller nulstiller mobil telefonen, bruges hvis telefonen mistes")
        LC_END
};

static lc_char PROGMEM lc_New_Key[]={
        LC_EN("New Key")
        LC_CZ("Novy klic")
	LC_FR("Nouvelle cl\5")
	LC_DE("Neuer Schl\176ssel")
	LC_DK("Ny N\14gle")
        LC_END
};

static lc_char PROGMEM lc_New_Key_Help[]={
        LC_EN("Create new key associated to phone number. If application is unlocked this key is used for secure SMS communication with given number. Every number can have own key.")
        LC_CZ("Vytvoreni klice pro urcite cislo. Po odemknuti aplikace se klic pouzije pro cteni/odeslani zprav pro dane cislo. Kazde cislo muze mit jiny tajny klic.")
	LC_FR("Cr\5e une nouvelle cl\5 associ\5e au No. de GSM. Cl\5 utilis\5e pour une communication SMS s\5curis\5e avec un No. donn\5. Chaque No. peut avoir sa cl\5.")	
	LC_DE("Schl\176sselentwurf f\176r bestimmte Nummer. Nach dem Entsperren der Applikation wird der Sch\176ssel zum lessen/versenden von Nachrichten der gew\173hlten Nummer benutzt. Jede Nummer kann einen anderen Schl\176ssel haben.")
	LC_DK("Opret ny n\14gle til telefonnummber. Hvis applikationen er L\17st op bliver denne n\14gle brugt til sikker SMS kommunikation med det givne nummer. Hver nummer kan have sin egen n\14gle.")
        LC_END
};

lc_char PROGMEM lc_Default_Crypted[]={
        LC_EN("Secure Message")
        LC_CZ("Sifrovana zprava")
	LC_FR("Message crypt\5")
	LC_DE("Verschl\176sselte Nachricht")
	LC_DK("Krypteret besked")
        LC_END
};

static lc_char PROGMEM lc_Key_Main[]={
        LC_EN("Main Key")
        LC_CZ("Hlavni klic")
	LC_FR("Cl\5 principale")
	LC_DE("Hauptschl\176ssel")
	LC_DK("Hovede N\14gle")
        LC_END
};

static lc_char PROGMEM lc_Key_Main_Help[]={
        LC_EN("Main key for application unlocking. All secret keys are protected with this key.")
        LC_CZ("Nastaveni hlavniho odemykaciho klice aplikace. Timto klicem jsou chraneny vsechny klice pro vlastni sifrovane SMS.")
	LC_FR("Cl\5 principale pour le d\5bocage des applications. Toutes les cl\5 secretes sont prot\5g\5es par cette cl\5.")
	LC_DE("Die Einstellung des Hauptschl\176ssels f\176r diese Applikation. Durch diesen Schl\176ssel sind alle Schl\176ssel f\176r die Eigenen verschl\176sselten SMS gesch\176tzt.")
	LC_DK("Hovede N\14gle bruges til at L\17se op. Alle hemmelige N\14gler beskyttes med Hovede N\14glen")
        LC_END
};

lc_char PROGMEM lc_Enter_Label[]={
        LC_EN("Enter Label:")
        LC_CZ("Zadejte oznaceni:")
	LC_FR("Entrez \5tiquette:")
	LC_DE("Markierung eingeben:")
	LC_DK("Skriv Tekst:")
        LC_END
};

/* *INDENT-ON* */

u8 make_main_key ()
{
  if (glob_mem->unlocked)
  {
    if (glob_mem->unlock_key_valid == 0)
    {
      u8 i;

      i = twofish_setup (&glob_mem->unlock_key, 16, &glob_mem->ak);
      if (i == NO_ERROR)
	glob_mem->unlock_key_valid = 1;
      return i;
    }
  }
  return NO_ERROR;
}

extern SNodeP crypted_n;

u8 PROGMEM t_bladox[] = "www.bladox.com";
u8 PROGMEM t_v_1[] = "Turbo SIM\n";
u8 PROGMEM t_v_2[] = "Security Edition\n";
u8 PROGMEM t_v_3[] = "SN: ";
u8 PROGMEM t_v_4[] = "FW: ";
u8 PROGMEM t_v_5[] = "v.";

u8 crypted_version (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    u8 i;
    u8 sn[16];
    u32 ver = version_turbo ();

// Turbo SIM - Security Edition\n
// Secure v.a.b.c
// SN: xxxx
// FW:
// www.bladox.com

    r = sprints (r, t_v_1);
    r = sprints (r, t_v_2);
//    r = sprints (r, t_Menu_Alpha);
//    r = sprintc (r, ' ');
    r = sprints (r, t_v_5);
    r = sprintc (r, VERSION_A + '0');
    r = sprintc (r, '.');
    r = sprintc (r, VERSION_B + '0');
    r = sprintc (r, '.');
    r = sprintc (r, VERSION_C + '0');
    r = sprintc (r, '\n');
    r = sprints (r, t_v_3);
    serial_number (sn);
    for (i = 0; i < 14; i++)
      r = sprintc (r, sn[i]);
    r = sprintc (r, '\n');
/*
    r = sprints (r, t_v_4);
    r = sprinti (r, (ver >> 24) & 0xFF);
    r = sprintc (r, '.');
    r = sprinti (r, (ver >> 16) & 0xFF);
    r = sprintc (r, '.');
    r = sprinti (r, (ver >> 8) & 0xFF);
    r = sprintc (r, '\n');
*/
    r = sprints (r, t_bladox);
    r = sprintc (r, '\0');

    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

/* *INDENT-OFF* */

lc_char PROGMEM lc_Auto[] = {
  	LC_EN("Automatic")
        LC_DE("Automatisch")
	LC_CZ("Automaticky")
	LC_NO("Automatisk")
	LC_FR("Automatique")
	LC_DK("Automatisk")
	LC_END
};

/* *INDENT-ON* */

#ifdef CONFIG_LANG_CZ
static u8 PROGMEM t_s5[] = "Cesky";
#endif

#ifdef CONFIG_LANG_EN
static u8 PROGMEM t_s6[] = "English";
#endif

#ifdef CONFIG_LANG_DE
static u8 PROGMEM t_s7[] = "Deutsch";
#endif

#ifdef CONFIG_LANG_NO
static u8 PROGMEM t_s8[] = "Norsk";
#endif

#ifdef CONFIG_LANG_FR
static u8 PROGMEM t_s9[] = "Fran\11ais";
#endif

#ifdef CONFIG_LANG_DK
static u8 PROGMEM t_s10[] = "Dansk";
#endif

static const u8 *PROGMEM l_lang[] = {
#ifdef CONFIG_LANG_CZ
  t_s5,
#endif

#ifdef CONFIG_LANG_EN
  t_s6,
#endif

#ifdef CONFIG_LANG_DE
  t_s7,
#endif

#ifdef CONFIG_LANG_FR
  t_s9,
#endif

#ifdef CONFIG_LANG_DK
  t_s10,
#endif

#ifdef CONFIG_LANG_NO
  t_s8,
#endif
};

static const u8 PROGMEM lang_hash[] = {
//  LC_AUTOMATIC,
#ifdef CONFIG_LANG_CZ
  LC_CZECH,
#endif

#ifdef CONFIG_LANG_EN
  LC_ENGLISH,
#endif

#ifdef CONFIG_LANG_DE
  LC_GERMAN,
#endif

#ifdef CONFIG_LANG_FR
  LC_FRENCH,
#endif

#ifdef CONFIG_LANG_DK
  LC_DANISH
#endif
#ifdef CONFIG_LANG_NO
    LC_NORWEGIAN
#endif
};

u8 crypted_lang (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 j;
    u8 lang = proc_8 (PROC_8_LANGUAGE);

    j = 0;
    while (rb (lang_hash + j) != lang && j < sizeof (lang_hash))
      j++;
    j++;
    res =
      select_item (sizeof (l_lang) / sizeof (u8 *), l_lang, locale (lc_Lang),
		   NULL /*locale (lc_Auto) */ , j, Q_SELECT_ITEM_CHOICE);
    j = get_tag (res, T_RESULT);
    if (j != 0)
    {
      j++;			// tag
      j++;			//len
      if (res[j] == 0x10)
	return APP_END;		// end
      if (res[j] == 0x11 || res[j] == 0x12)
	return APP_BACK;	// back
    }

    j = get_tag (res, T_ITEM_ID);
    if (j != 0)
    {
      j++;			//tag
      j++;			//len
      j = res[j];
      j = rb (lang_hash + j - 1);
      if (j != lang)
      {
	set_proc_8 (PROC_8_LANGUAGE, j);
	set_up_menu ();
      }
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_msg_ctx (SCtx * ctx, u8 action);

extern SNodeP crypted_n_keys_stealth;
extern SNodeP crypted_n_keys_view;
extern SNodeP crypted_n_keys_edit;
extern SNodeP crypted_n_keys_delete;

u8 crypted_keys_ctx (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->n;
    Crypt_key *key = rw (&n->p);

    if (rb (&key->stealth) == 0)
    {
      spider_append_r (ctx, &crypted_n_keys_stealth);
      spider_append_r (ctx, &crypted_n_keys_delete);
      spider_append_r (ctx, &crypted_n_keys_edit);
      spider_append_r (ctx, &crypted_n_keys_view);
    }
    else
      spider_append_r (ctx, &crypted_n_keys_delete);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 crypted_keys_delete (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res;
    SNode *n = ctx->parent->f;
    Pers_mem *p = app_data ();

    res = yesno (rw (&n->text), Q_YESNO_DELETE_QMARK, 0);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      SEdge *e = glob_mem->crypted_keys;
      SEdge *f = e;
      Crypt_key *k = rw (&n->p);

      while (e)
      {
	if (rw (&e->t) == n)
	  break;
	f = e;
	e = rw (&e->next);
      }

      if (f == e)
      {
	ww (&p->crypted_keys, rw (&e->next));
	glob_mem->crypted_keys = rw (&e->next);
      }
      else
      {
	ww (&f->next, rw (&e->next));
      }

      efree (rw (&k->msisdn));
      efree (rw (&n->text));
      efree (rw (&n->p));
      efree (n);
      efree (e);

      spider_back (ctx);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_keys_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->parent->f;
    Crypt_key *key = rw (&n->p);
    u8 i;
    u8 *buf = buf_B ();
    u8 *ms;

    if (make_main_key () != NO_ERROR)
      return perror (ERR_NO_RAM);

    ms = msisdn2str (rw (&key->msisdn), MSISDN_ADN, MEM_R);
    if (ms == NULL)
      return perror (ERR_NO_RAM);

    twofish_ecb_decrypt (&key->text, buf + 2, &glob_mem->ak);
    buf[0] = STRING_SLV;
    buf[1] = 0;			//7b dcs
    i = display_text (buf, ms);
    free (ms);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

u8 crypted_keys_stealth (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->parent->f;
    Crypt_key *key = rw (&n->p);
    u8 res;

    res = yesno (locale (lc_Stealth), Q_YESNO_QMARK, 0);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      wb (&key->stealth, 1);
    }
    return APP_BACK;
  }
  return APP_OK;
}

void make_crypt_key (u8 * buf, u8 * res, u8 key_len)
{
  u8 i;
  u8 tmp[16];

  dbsp ("MAKE_CRYPT_KEY ");
  dbch (key_len);
  dbc ('\n');

  bzero (tmp, 16);

  if (key_len > 16)
    key_len = 16;
  for (i = 0; i < key_len; i++)
    tmp[i] = res[i];
  buf[0] = key_len;
  key_len = dcs_78 (tmp, key_len, DCS_8_TO_7);
  for (i = 1; i < 16; i++)
    buf[i] = 16 - key_len;
  for (i = 0; i < key_len; i++)
    buf[i + 1] = tmp[i];

#ifdef DEBUG
  for (i = 0; i < 16; i++)
  {
    dbch (buf[i]);
    dbc (' ');
  }
  dbc ('\n');
#endif
}

u8 crypted_keys_edit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->parent->f;
    Crypt_key *key = rw (&n->p);
    u8 *buf = buf_B ();
    u8 *res;
    u8 i;
    u8 key_len;

    i = password (buf, 16, locale (lc_New_Key));
    if (i != APP_OK)
      return i;

    if (make_main_key () != NO_ERROR)
      return perror (ERR_NO_RAM);

    twofish_ecb_encrypt (buf, &key->text, &glob_mem->ak);
    return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_keys_main_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 i = display_text (locale (lc_Key_Main_Help), NULL);

    if (i != APP_END)
      return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_keys_main_edit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 err;
    Twofish_key *key = NULL;
    u8 *res;
    u8 *buf = buf_B ();
    u8 *k = buf;
    u8 *in = buf + 16;
    u8 *out = in + 16;
    Pers_mem *p = app_data ();
    u8 key_len;
    u8 i;
    SEdge *keys;
    SNode *n;
    Crypt_key *ck;

//XXXBACK
    spider_back (ctx);
    i = password (k, 16, locale (lc_New_Key));
    if (i != APP_OK)
      return i;

    if (make_main_key () != NO_ERROR)
    {
      err = ERR_NO_RAM;
      goto X_ERR;
    }

    xrand (in);
    xrand (in + 8);

    key = malloc (sizeof (Twofish_key));
    if (key == NULL)
    {
      err = ERR_NO_RAM;
      goto X_ERR;
    }

#ifdef DEBUG
    dbsp ("MAIN_KEY: ");
    for (i = 0; i < 16; i++)
    {
      dbch (k[i]);
      dbc (' ');
    }
    dbc ('\n');
#endif

    err = twofish_setup (k, 16, key);
    if (err != NO_ERROR)
      goto X_ERR;

    memcpy (&glob_mem->unlock_key, k, 16);
    memcpy (&p->main_key_rnd, in, 16);
    twofish_ecb_encrypt (in, &p->main_key_crnd, key);

    keys = glob_mem->crypted_keys;
    while (keys)
    {
      n = rw (&keys->t);
      ck = rw (&n->p);
      twofish_ecb_decrypt (&ck->text, out, &glob_mem->ak);
      twofish_ecb_encrypt (out, &ck->text, key);
      keys = rw (&keys->next);
    }

    memcpy (&glob_mem->ak, key, sizeof (Twofish_key));	//XXXAK
    glob_mem->unlock_key_valid = 1;
    free (key);

    return APP_BACK;

  X_ERR:
    free (key);
    return perror (err);
  }
  return APP_OK;
}

u8 crypted_keys_new_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 i = display_text (locale (lc_New_Key_Help), NULL);

    if (i != APP_END)
      return APP_BACK;
  }
  return APP_OK;
}

extern SNodeP crypted_n_keys;

u8 crypted_keys_new_insert (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    Crypt_key *key = NULL;
    u8 *key_msisdn = NULL;
    SNode *n = NULL;
    u8 *n_text = NULL;
    SEdge *e = NULL;
    u8 alpha[ALPHA_LEN];
    u8 alpha_len;
    u8 *res;
    u8 i, j;
    u8 *buf = buf_B ();
    u8 key_len;

//XXXBACK
    spider_back (ctx);

    if (make_main_key () != NO_ERROR)
      return perror (ERR_NO_RAM);

    key = emalloc (sizeof (Crypt_key));
    if (key == NULL)
      goto X_ERR;

    n = emalloc (sizeof (SNode));
    if (n == NULL)
      goto X_ERR;

    e = emalloc (sizeof (SEdge));
    if (e == NULL)
      goto X_ERR;

    res = msisdn (alpha);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }

    key_msisdn = msisdncpy (res, MSISDN_ADN, MEM_E);
    if (key_msisdn == NULL)
      goto X_ERR;

    alpha_len = strlen (alpha) + 1;
    n_text = emalloc (alpha_len);
    if (n_text == NULL)
      goto X_ERR;

    memcpy (n_text, alpha, alpha_len);

    ww (&n->p, key);
    ww (&n->text, n_text);
    ww (&n->cb, crypted_keys_ctx);

    i = password (buf, 16, locale (lc_New_Key));
    if (i != APP_OK)
      goto X_END;

    twofish_ecb_encrypt (buf, &key->text, &glob_mem->ak);

    wb (&key->stealth, 0);
    ww (&key->msisdn, key_msisdn);
    ww (&e->f, &crypted_n_keys);
    ww (&e->t, n);
    wb (&e->source, MEM_F_P | MEM_T_E);

    {
      Pers_mem *p = app_data ();

      insert_sorted_alpha (e, &p->crypted_keys, alpha);
      glob_mem->crypted_keys = rw (&p->crypted_keys);
    }

    return APP_BACK;
  X_ERR:
    i = APP_OK;
  X_END:
    efree (key);
    efree (key_msisdn);
    efree (e);
    efree (n);
    efree (n_text);

    if (i == APP_OK)
      i = perror (ERR_NO_EEPROM);
    return i;
  }
  return APP_OK;
}

u8 crypted_send (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    return send_msg (MSG_CRYPTED, NULL, NULL, 0);	// TODO ucs2
  }
  return APP_OK;
}

u8 crypted_msg_reply (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->parent->f;
    Crypted_msg *msg = n->p;

    return send_msg (MSG_CRYPTED, NULL, msg->msisdn, 0);	// TODO ucs2
  }
  return APP_OK;
}

u8 crypted_unlock (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 err;
    u8 *res;
    u8 *buf = buf_B ();
    u8 *k = buf;
    u8 *in = buf + 16;
    u8 *out = in + 16;
    Pers_mem *p = app_data ();
    u8 key_len;
    u8 i;

    glob_mem->unlock_key_valid = 0;
    glob_mem->unlocked = 0;

    i = password (k, 16, NULL);
    if (i != APP_OK)
      return i;

#ifdef DEBUG
    dbsp ("UNLOCK_KEY: ");
    for (i = 0; i < 16; i++)
    {
      dbch (k[i]);
      dbc (' ');
    }
    dbc ('\n');
#endif

    err = twofish_setup (k, 16, &glob_mem->ak);
    if (err != NO_ERROR)
      goto X_ERR;

    for (i = 0; i < 16; i++)
      glob_mem->unlock_key[i] = k[i];

    twofish_ecb_encrypt (&p->main_key_rnd, out, &glob_mem->ak);

#ifdef DEBUG
    dbsp ("IN_RND: ");
    for (i = 0; i < 16; i++)
    {
      dbch (in[i]);
      dbc (' ');
    }
    dbc ('\n');
    dbsp ("OUT_CRND: ");
    for (i = 0; i < 16; i++)
    {
      dbch (out[i]);
      dbc (' ');
    }
    dbc ('\n');

#endif

    if (memcmp (out, p->main_key_crnd, 16))
    {
      err = ERR_WRONG_KEY;
      goto X_ERR;
    }

    glob_mem->unlock_key_valid = 1;
    glob_mem->unlocked = 1;

    return APP_BACK;
  X_ERR:
    return perror (err);
  }
  return APP_OK;
}

u8 decrypt_msg (u8 * s)
{
  SNode *n;
  SEdge *msisdns;
  Crypt_key *c_key;
  u8 *t;
  u8 i;
  u8 len;
  u8 *buf;
  u8 *in;
  u8 *msg;
  u8 j;

  if (make_main_key () != NO_ERROR)
    return perror (ERR_NO_RAM);

  buf = glob_mem->msg_buf;
  in = buf + 16;
  t = tpdu_seek (s, T_SMS_AA);

  if (glob_mem->unlocked)
  {
    msisdns = glob_mem->crypted_keys;
    while (msisdns)
    {
      dbsp ("CR_4\n");
      n = rw (&msisdns->t);
      c_key = rw (&n->p);
      if (msisdncmp (t, MSISDN_SMS, rw (&c_key->msisdn), MSISDN_ADN))
      {
	dbsp ("CR_5\n");
	// found crypted key

	twofish_ecb_decrypt (&c_key->text, in, &glob_mem->ak);
	goto X1;
      }

      msisdns = rw (&msisdns->next);
    }
  }

  i = password (in, 16, NULL);
  if (i != APP_OK)
    return i;

X1:

  t = tpdu_seek (s, T_SMS_UD);
  msg = t + 12;

  i = twofish_setup (in, 16, &glob_mem->ak);
  glob_mem->unlock_key_valid = 0;
  if (i == NO_ERROR)
    i = twofish_cbc_decrypt (msg, msg, 8, &glob_mem->ak);

  if (i != NO_ERROR)
    return perror (i);

  len = t[20];
  if (len > 0xA0)
    len = 0xA0;

  for (i = 0; i < len; i++)
    t[i] = msg[i + 9];

  *(t - 2) = 0;			// 7b dcs
  *(t - 1) = dcs_7b_len (len);

  return APP_OK;
}

u8 crypted_msg_delete (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 path[6];
    SNode *n = ctx->parent->f;
    Crypted_msg *msg = n->p;
    u8 i;
    u8 *t = buf_B ();
    u8 res;

    path[0] = 0;		// no text, just "Delete ?"

    res = yesno (path, Q_YESNO_DELETE_QMARK, 0);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      delete_crypted (msg->p1);
      memcpy (path, ef_sms_path, 6);
      select (path, 3);
      for (i = 0; i < 0xb0; i++)
	t[i] = 0xff;
      t[0] = 0x00;
      sim (ME_CMD_UPDATE_RECORD, msg->p1, 0x04, 0xb0, t);
      select (0, 0);

      dbsp (">refresh_sms\n");
      refresh (Q_REFRESH_SIM_FILE_CHANGE, 1, 6, path);
      dbsp ("<refresh_sms\n");

      spider_back (ctx);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_msg_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 path[6];
    SNode *n = ctx->parent->f;
    SEdge *msisdns;
    Crypted_msg *msg = n->p;
    u8 i;
    u8 *t;
    Crypt_key *c_key;
    u8 *buf;
    u8 *in;
    u8 len;

    if (make_main_key () != NO_ERROR)
      return perror (ERR_NO_RAM);

    buf = glob_mem->msg_buf;
    in = buf + 16;

    if (glob_mem->unlocked)
    {
      msisdns = glob_mem->crypted_keys;
      while (msisdns)
      {
	dbsp ("CR_4\n");
	n = rw (&msisdns->t);
	c_key = rw (&n->p);
	if (msisdncmp (msg->msisdn, MSISDN_SMS, rw (&c_key->msisdn), MSISDN_ADN))	//XXXMS
	{
	  dbsp ("CR_5\n");
	  // found crypted key

	  twofish_ecb_decrypt (&c_key->text, in, &glob_mem->ak);
	  goto X1;
	}

	msisdns = rw (&msisdns->next);
      }
    }

    i = password (in, 16, NULL);
    if (i != APP_OK)
      return i;

  X1:
    memcpy (path, ef_sms_path, 6);
    select (path, 3);
    sim (ME_CMD_READ_RECORD, msg->p1, 0x04, 0xb0, buf_B ());
    memcpy (buf_A (), buf_B (), 0xFF);
    select (0, 0);		// uses buf_B()
    memcpy (buf_B (), buf_A (), 0xFF);

    {
      u8 *msg;
      u8 j;
      u8 *s = buf_B ();
      u8 ver;

      s++;
      i = *s;
      s = s + 1 + i;		//skip SMSC

      t = tpdu_seek (s, T_SMS_UD);

      ver = t[9];
      if (ver == 0xcb)
	ver = 0;

      msg = t + 12;

      i = twofish_setup (in, 16, &glob_mem->ak);
      glob_mem->unlock_key_valid = 0;
      if (i != NO_ERROR)
	return perror (i);

      i = twofish_cbc_decrypt (msg, msg, 8, &glob_mem->ak);
      if (i == NO_ERROR)
      {
	len = t[20];		// in septets or ucs2
	if (len > 0xA0)
	  len = 0xA0;

	if (ver)
	  ver = t[19] & 0x01;	//ucs2

	*(t - 3) = STRING_SLV;

	if (ver)
	{
// ucs2
	  j = len;
	  for (i = 0; i < j; i++)
	    t[i] = msg[i + 9];
	  *(t - 2) = 0x08;	// ucs2 dcs
	}
	else
	{
// 7b dcs
	  j = (len * 7) / 8 + 1;
	  for (i = 0; i < j; i++)
	    t[i] = msg[i + 9];
	  *(t - 2) = 0;		// 7b dcs
	}

//      *(t - 1) = dcs_7b_len (len);    // nr of septets
	*(t - 1) = len;

	//view
	i = display_text (t - 3, NULL);
	if (i != APP_END)
	  i = APP_BACK;
      }
      else
	i = perror (i);
    }
    return i;
  }
}

extern SNodeP crypted_n_msg_reply;
extern SNodeP crypted_n_msg_view;
extern SNodeP crypted_n_msg_delete;

u8 crypted_msg_ctx (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    spider_append_r (ctx, &crypted_n_msg_delete);
    spider_append_r (ctx, &crypted_n_msg_reply);
    spider_append_r (ctx, &crypted_n_msg_view);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 crypted_keys (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
//    ctx->n_default = 2;
    ctx->eE = glob_mem->crypted_keys;
  }
  else if (action == APP_LEAVE)
  {
    ctx->eE = NULL;
  }
  return APP_OK;
}

extern SNodeP crypted_n_reset_sms_edit;
extern SNodeP crypted_n_reset_sms_send;
extern SNodeP crypted_n_reset_sms_help;

u8 crypted_reset_sms_ctx (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    spider_append_r (ctx, &crypted_n_reset_sms_help);
    spider_append_r (ctx, &crypted_n_reset_sms_send);
    spider_append_r (ctx, &crypted_n_reset_sms_edit);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 crypted_reset_sms_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 i = display_text (locale (lc_RESET_SMS_Help), NULL);

    if (i != APP_END)
      return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_reset_sms_send (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    return send_msg (MSG_KILL, NULL, NULL, 0);
  }
  return APP_OK;
}

u8 crypted_reset_sms_edit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    Pers_mem *pers = app_data ();
    u8 *res;
    u8 *reset_sms = rw (&pers->reset_sms);
    u8 l;

    res =
      get_input (locale (lc_RESET_SMS), 0, 100, reset_sms,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;

    efree (reset_sms);

    l = res[0];

    if (l < 2)
      reset_sms = NULL;
    else
    {
      res[res[0] + 1] = '\0';
      reset_sms = emalloc (l);
      if (reset_sms == NULL)
      {
	ww (&pers->reset_sms, NULL);
	return perror (ERR_NO_EEPROM);
      }
      memcpy (reset_sms, res + 2, l);
    }
    ww (&pers->reset_sms, reset_sms);

    return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_label_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 i = display_text (locale (lc_Label_Help), NULL);

    if (i != APP_END)
      return APP_BACK;
  }
  return APP_OK;
}

u8 crypted_label_edit (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    Pers_mem *pers = app_data ();
    u8 *res;
    u8 *label = rw (&pers->crypted_label);
    u8 l;

//XXXBACK
    spider_back (ctx);

    res =
      get_input (locale (lc_Enter_Label), 0, 100, label,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;

    efree (label);

    l = res[0];

    if (l < 2)
      label = NULL;
    else
    {
      res[res[0] + 1] = '\0';
      label = emalloc (l);
      if (label == NULL)
      {
	ww (&pers->crypted_label, NULL);
	return perror (ERR_NO_EEPROM);
      }
      memcpy (label, res + 2, l);
    }
    ww (&pers->crypted_label, label);

    return APP_BACK;
  }
  return APP_OK;
}

u8 my_strcmp (u8 * x, u8 * y)	// 1 equal, 0 non equal
{
  u8 i;
  u8 l;

  l = strlen (x);
  if (l != strlen (y))
    return 0;

  for (i = 0; i < l; i++)
    if (x[i] != y[i])
      return 0;
  return 1;
}

extern SNodeP crypted_n_locked;
extern SNodeP crypted_n_unlocked;
extern SNodeP crypted_n_keys;
extern SNodeP crypted_n_reset_sms_ctx;

u8 crypted_ctx (SCtx * ctx, u8 action)
{
  dbsp (">crypted_ctx\n");
  if (action == APP_ENTER)
  {
    SEdge *x, *y;
    SNode *nx, *ny;
    Crypted_msg *mx, *my;
    u8 nr_adn;
    u8 *tmp_adn;
    u8 i;

#define MAX_CONV_ADN	1

    dbsp (">crypted_ctx_enter\n");
    dbsp ("crypted_msgs ");
    dbih (glob_mem->crypted_msgs);
    dbc ('\n');

// MSISDN->ADN
    if (adn_ready ())
    {
      dbsp ("CONV_ADN\n");
      x = glob_mem->crypted_msgs;
      nr_adn = 0;
      while (x && nr_adn < MAX_CONV_ADN)
      {
	nx = x->t;
	mx = nx->p;
	if (mx->adn_ready == 0)
	{
	  dbsp ("CONV_ADN_1\n");
	  tmp_adn = get_adn (mx->msisdn, MSISDN_SMS);
	  nr_adn++;
	  if (tmp_adn == NULL)
	    return perror (ERR_NO_RAM);

	  mx->adn_ready = 1;

	  if (my_strcmp (tmp_adn, nx->text) == 0)	// not equal
	  {
	    dbsp ("CONV_ADN_2\n");
	    free (nx->text);
	    nx->text = tmp_adn;
	  }
	  else
	    free (tmp_adn);

	  y = x->next;
	  while (y)
	  {
	    ny = y->t;
	    my = ny->p;

	    if (my->adn_ready == 0)
	    {
	      dbsp ("CONV_ADN_3\n");
	      for (i = 0; i < 8; i++)
		if (my->msisdn[i] != mx->msisdn[i])
		  goto X_NO_MATCH;
	      if (my_strcmp (ny->text, nx->text) == 0)
	      {
		dbsp ("CONV_ADN_4\n");
		if (strlen (ny->text) > strlen (nx->text))	// save malloc
		{
		  dbsp ("CONV_ADN_5\n");
		  memcpy (ny->text, nx->text, strlen (nx->text) + 1);
		  my->adn_ready = 1;
		}
		else
		{
		  dbsp ("CONV_ADN_6\n");
		  tmp_adn = malloc (strlen (nx->text) + 1);
		  if (tmp_adn)
		  {
		    dbsp ("CONV_ADN_7\n");
		    memcpy (tmp_adn, nx->text, strlen (nx->text) + 1);
		    free (ny->text);
		    ny->text = tmp_adn;
		    my->adn_ready = 1;
		  }
		}
	      }
	    }
	  X_NO_MATCH:
	    y = y->next;
	  }
	}
	x = x->next;
      }
    X_END:
    }

    glob_mem->crypted_msgs_tmp = NULL;

    if (glob_mem->unlocked)
    {
      ctx->eR = glob_mem->crypted_msgs;
      glob_mem->crypted_msgs_tmp = glob_mem->crypted_msgs;
      dbsp ("ctx->eR ");
      dbih (ctx->eR);
      dbc ('\n');

      spider_append_r (ctx, &crypted_n_reset_sms_ctx);
      spider_append_r (ctx, &crypted_n_keys);
    }
    else
      spider_append_r (ctx, &crypted_n_locked);

    dbsp ("ctx->eR_1 ");
    dbih (ctx->eR);
    dbc ('\n');
  }
  else if (action == APP_LEAVE)
  {
    SEdge *e = ctx->eR;

    dbsp (">crypted_ctx_leave\n");

    while (e)
    {
      dbsp ("cleaning\n");
      if (e->next && e->next == glob_mem->crypted_msgs_tmp)
      {
	e->next = NULL;
	break;
      }
      e = e->next;
    }

    spider_clear_r (ctx);
    dbsp ("<crypted_ctx_leave\n");
  }
  return APP_OK;
}

SNodeP crypted_n = { NULL, crypted_ctx };
static SNodeP crypted_n_send = { lc_Send_crypted, crypted_send };
static SNodeP crypted_n_locked = { lc_Unlock, crypted_unlock };
static SNodeP crypted_n_reset_sms_ctx =
  { lc_RESET_SMS, crypted_reset_sms_ctx };
static SNodeP crypted_n_reset_sms_edit = { LC_EDIT, crypted_reset_sms_edit };
static SNodeP crypted_n_reset_sms_send =
  { lc_Send_RESET_SMS, crypted_reset_sms_send };
static SNodeP crypted_n_reset_sms_help = { LC_HELP, crypted_reset_sms_help };
static SNodeP crypted_n_version = { lc_Version, crypted_version };
static SNodeP crypted_n_lang = { lc_Lang, crypted_lang };
static SNodeP crypted_n_label = { lc_Label, NULL };
static SNodeP crypted_n_label_edit = { LC_EDIT, crypted_label_edit };
static SNodeP crypted_n_label_help = { LC_HELP, crypted_label_help };
static SNodeP crypted_n_keys = { lc_Setup, crypted_keys };
static SNodeP crypted_n_keys_new = { lc_New_Key, NULL };
static SNodeP crypted_n_keys_new_insert =
  { lc_Insert, crypted_keys_new_insert };
static SNodeP crypted_n_keys_new_help = { LC_HELP, crypted_keys_new_help };
static SNodeP crypted_n_keys_stealth = { lc_Stealth, crypted_keys_stealth };
static SNodeP crypted_n_keys_view = { LC_VIEW, crypted_keys_view };
static SNodeP crypted_n_keys_delete = { LC_DELETE, crypted_keys_delete };
static SNodeP crypted_n_keys_edit = { LC_EDIT, crypted_keys_edit };
static SNodeP crypted_n_keys_main = { lc_Key_Main, NULL };
static SNodeP crypted_n_keys_main_edit = { LC_EDIT, crypted_keys_main_edit };
static SNodeP crypted_n_keys_main_help = { LC_HELP, crypted_keys_main_help };
static SNodeP crypted_n_msg_view = { LC_VIEW, crypted_msg_view };
static SNodeP crypted_n_msg_delete = { LC_DELETE, crypted_msg_delete };
static SNodeP crypted_n_msg_reply = { lc_Msg_Reply, crypted_msg_reply };

SEdgeP crypted_edges_p[] = {
  {&crypted_n, &crypted_n_send},
  {&crypted_n_keys, &crypted_n_version},
  {&crypted_n_keys, &crypted_n_lang},
  {&crypted_n_keys, &crypted_n_label},
  {&crypted_n_keys, &crypted_n_keys_main},
  {&crypted_n_keys, &crypted_n_keys_new},
  {&crypted_n_label, &crypted_n_label_edit},
  {&crypted_n_label, &crypted_n_label_help},
  {&crypted_n_keys_main, &crypted_n_keys_main_edit},
  {&crypted_n_keys_main, &crypted_n_keys_main_help},
  {&crypted_n_keys_new, &crypted_n_keys_new_insert},
  {&crypted_n_keys_new, &crypted_n_keys_new_help},
  NULL
};

#endif
