#ifndef __PROCSMS_H_
#define __PROCSMS_H_

#include "archive.h"
#include "crypted.h"
#include "masked.h"

// max nr of SMS on SIM, minimum of this and SIM SMS positions
#define DEF_SMS_REC_NR          0x0A

// sizeof(Smsing_mem) = 0x016c =364b // CRYPTED, ONDISPLAY only

typedef struct _Smsing_mem
{
#ifdef CONFIG_MASKED
  u8 mask_locked;
  Mask_key *mask_keys;		// pointer to eeprom to key list
  Mask_key *masked_key;		// current key
  u8 *masked_new_key;
#endif

#ifdef CONFIG_CRYPTED
  SEdge *crypted_keys;
  SEdge *crypted_msgs;
  SEdge *crypted_msgs_tmp;
  Twofish_key ak;
  u8 unlock_key[16];
  u8 unlock_key_valid;
  u8 unlocked;
#endif

  u8 *sms_rec;
  u8 sms_rec_nr;

  u8 c2_dcs_7b;

  u8 warn;
#define MAX_MSG_LEN	143
  u8 msg_buf[MAX_MSG_LEN];

#ifdef CONFIG_ARCHIVE
  u8 activ;
  b32 tmp_b;
  b32 smi;
  b32 sms;
  b32 rules;
  b32 links;
  b32 parent_pwd;
  b32 _pwd;
  u8 is_rules;
  b32 drop;
#endif
}
Smsing_mem;

typedef struct _Pers_mem
{
#ifdef CONFIG_MASKED
  Mask_key *mask_keys;		// pointer to eeprom to key list
#endif

#ifdef CONFIG_CRYPTED
  SEdge *crypted_keys;		// pointer to eeprom to key list
  u8 main_key_rnd[16];
  u8 main_key_crnd[16];
  u8 *reset_sms;
  u8 *crypted_label;
#endif

#ifdef CONFIG_ARCHIVE
  u8 activ;
#endif
}
Pers_mem;

extern Smsing_mem *glob_mem;

#define MSG_CRYPTED     0
#define MSG_MASKED      1
#define MSG_ON_DISPLAY  2
#define MSG_PLAIN       3
#define MSG_KILL        4

u8 send_msg (u8 type, u8 * def_text, u8 * def_ms, u8 ucs2);

extern u8 PROGMEM ef_sms_path[];
extern u8 PROGMEM t_Menu_Alpha[];

extern lc_char PROGMEM lc_Msg_Reply[];
extern lc_char PROGMEM lc_Msg_Forward[];

void insert_sorted_alpha (SEdge * e, SEdge ** start, u8 * alpha);
u8 check_mask (u8 * s, u8 p1);
u8 check_crypted (u8 * t);
void delete_crypted (u8 p1);

#endif
